## scythe 0.994

=== Makefile ===
PROGRAM_NAME = scythe
VERSION = 0.991
CC = gcc
DEBUG ?= 0
CFLAGS = -Wall -pedantic -DVERSION=$(VERSION) -std=gnu99
ifeq ($(DEBUG), 1)
	CFLAGS += -g -O0
else 
	CFLAGS += -O3
endif
ARCHIVE = $(PROGRAM_NAME)_$(VERSION)
LDFLAGS = -lz -lm
LDTESTFLAGS = -lcheck
SDIR = src
OBJS = match.o scythe.o util.o prob.o 
LOBJS = match.o util.o prob.o 


.PHONY: clean default all distclean dist tests testclean lib

default: all

%.o: $(SDIR)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

match.o: $(SDIR)/scythe.h
scythe.o: $(SDIR)/kseq.h $(SDIR)/scythe.h
util.o: $(SDIR)/kseq.h $(SDIR)/scythe.h
prob.o: $(SDIR)/scythe.h
test.o: $(SDIR)/scythe.h

valgrind: build
	valgrind --leak-check=full --show-reachable=yes ./scythe -a solexa_adapters.fa test.fastq

test: clean match.o util.o prob.o test.o
	$(CC) $(CFLAGS) $? -o test $(LDFLAGS) $(LDTESTFLAGS) && ./test

testclean:
	rm -rf ./tests

clean:
	rm -rf *.o ./scythe *.dSYM

distclean: clean
	rm -rf *.tar.gz

dist:
	tar -zcf $(ARCHIVE).tar.gz src Makefile

all: $(OBJS)
	$(CC) $(CFLAGS) $? -o scythe $(LDFLAGS)

lib: libscythe.so

libscythe.so: CFLAGS += -fpic
libscythe.so: $(LOBJS)
	$(CC) $(CFLAGS) -shared -o $@ $^ $(LDFLAGS)

=== debian/changelog ===
scythe (0.994-4) unstable; urgency=medium

  * Team upload.
  * Really treat VERSION as string
    Closes: #857900

 -- Andreas Tille <tille@debian.org>  Thu, 16 Mar 2017 14:22:02 +0100

scythe (0.994-3) unstable; urgency=medium

  [ Kevin Murray ]
  * Comment out watchfile, upstream doesn't actually provide tags on github
  * Fix vcs git URL
  * Bump standards version

  [ Mattia Rizzolo ]
  * debian/rules: remove useless include

 -- Kevin Murray <spam@kdmurray.id.au>  Thu, 17 Mar 2016 12:39:24 +0000

scythe (0.994-2) unstable; urgency=low

  * Fix copyright of kseq.h in d/control
  * Patch Makefile to pull in hardening flags correctly
  * Add compiled readme to gitignore

 -- Kevin Murray <spam@kdmurray.id.au>  Mon, 19 Oct 2015 11:27:51 +1100

scythe (0.994-1) unstable; urgency=medium

  * Initial release. (Closes: #776179)

 -- Kevin Murray <spam@kdmurray.id.au>  Sun, 25 Jan 2015 11:09:57 +1100

=== debian/control ===
Source: scythe
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               zlib1g-dev,
               python-markdown,
               check
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/git/debian-med/scythe.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/scythe.git
Homepage: https://github.com/vsbuffalo/scythe

Package: scythe
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Bayesian adaptor trimmer for sequencing reads
 Scythe uses a Naive Bayesian approach to classify contaminant substrings in
 sequence reads. It considers quality information, which can make it robust in
 picking out 3'-end adapters, which often include poor quality bases.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	markdown_py -f README.html README.md

get-orig-source:
	@echo "Downloading source from GitHub"
	wget -O scythe_0.994.orig.tar.gz https://api.github.com/repos/vsbuffalo/scythe/tarball/20d3cff7d7f483bd779aff75f861e93708c0a2b5

=== debian/watch ===
#version=3
#https://github.com/vsbuffalo/scythe/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## scythe 0.994%2Bgit20141017.20d3cff

=== testing/Makefile ===
clean:
	rm -rf scythe/results/*
	rm -rf cutadapt/results/*
	rm -rf btrim/results/*

clean-simulated-reads:
	rm -rf simulated-reads/*

run-trimmers:
	bash run.sh 0.4
	bash run.sh 0.7

generate-reads:
	R CMD BATCH generate-reads.R

## scythe 0.994+git20141017.20d3cff

=== debian/changelog ===
scythe (0.994+git20141017.20d3cff-3) unstable; urgency=medium

  * Team Upload.
  * Add autopkgtests
  * compat version: 13, standards version: 4.5.0
  * Add "Rules-Requires-Root:no"
  * Add hardening options

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 14 Aug 2020 15:30:00 +0530

scythe (0.994+git20141017.20d3cff-2) unstable; urgency=medium

  * Team upload.
  * Replace python-markdown by markdown
    Closes: #943255
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

 -- Andreas Tille <tille@debian.org>  Mon, 16 Dec 2019 10:00:23 +0100

scythe (0.994+git20141017.20d3cff-1) unstable; urgency=medium

  * d/watch: use git mode
  * Drop unneeded get-orig-source target
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.0

 -- Andreas Tille <tille@debian.org>  Fri, 24 Aug 2018 17:50:51 +0200

=== debian/control ===
Source: scythe
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               zlib1g-dev,
               markdown,
               check
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/scythe
Vcs-Git: https://salsa.debian.org/med-team/scythe.git
Homepage: https://github.com/vsbuffalo/scythe
Rules-Requires-Root: no

Package: scythe
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Bayesian adaptor trimmer for sequencing reads
 Scythe uses a Naive Bayesian approach to classify contaminant substrings in
 sequence reads. It considers quality information, which can make it robust in
 picking out 3'-end adapters, which often include poor quality bases.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	markdown README.md > README.html

=== debian/watch ===
version=4

opts="mode=git,pretty=0.994+git%cd.%h" \
    https://github.com/vsbuffalo/scythe.git HEAD

## scythe engine-0.0.29

=== Makefile ===
.PHONY: install
install: ## Install the poetry environment and install the pre-commit hooks
	@echo "🚀 Creating virtual environment using uv"
	@uv sync --all-groups --all-extras
	@uv run pre-commit install

.PHONY: clean-env
clean-env: ## Clean the uv environment
	@echo "🚀 Removing .venv directory created by uv (if exists)"
	@rm -rf .venv

.PHONY: check
check: ## Run code quality tools.
	@echo "🚀 Checking lock file consistency with 'pyproject.toml'"
	@uv lock --locked
	@echo "🚀 Linting code: Running pre-commit"
	@uv run pre-commit run -a
	@echo "🚀 Static type checking: Running pyright"
	@uv run pyright

.PHONY: test
test: ## Test the code with pytest
	@echo "🚀 Testing code: Running pytest"
	@uv run pytest --cov --cov-config=pyproject.toml --cov-report=xml


.PHONY: build
build: clean-build ## Build wheel file
	@echo "🚀 Creating wheel file"
	@uvx --from build pyproject-build --installer uv

.PHONY: clean-build
clean-build: ## Clean build artifacts
	@echo "🚀 Removing build artifacts"
	@uv run python -c "import shutil; import os; shutil.rmtree('dist') if os.path.exists('dist') else None"

.PHONY: publish
publish: ## Publish a release to PyPI.
	@echo "🚀 Publishing."
	@uvx twine upload --repository-url https://upload.pypi.org/legacy/ dist/*

.PHONY: build-and-publish
build-and-publish: build publish ## Build and publish.

.PHONY: docs-test
docs-test: ## Test if documentation can be built without warnings or errors
	@uv run mkdocs build -s

.PHONY: docs
docs: ## Build and serve the documentation
	@uv run mkdocs serve

.PHONY: docs-deploy
docs-deploy: ## Build and serve the documentation
	@uv run mkdocs gh-deploy

.PHONY: help
help:
	@uv run python -c "import re; \
	[[print(f'\033[36m{m[0]:<20}\033[0m {m[1]}') for m in re.findall(r'^([a-zA-Z_-]+):.*?## (.*)$$', open(makefile).read(), re.M)] for makefile in ('$(MAKEFILE_LIST)').strip().split()]"

.PHONY: create-copilot-app
create-copilot-app: ## Create the entire stack with copilot
	@copilot app init
	@copilot env init --name prod
	@copilot env deploy --name prod
	@copilot secret init --name HATCHET_CLIENT_TOKEN
	@copilot deploy --init-wkld --env prod --all

.DEFAULT_GOAL := help

## scythe ttp-0.18.5

=== requirements.txt ===
PySocks==1.7.1
attrs==25.3.0
certifi==2025.6.15
charset-normalizer==3.4.2
h11==0.16.0
idna==3.10
outcome==1.3.0.post0
pydantic-core==2.18.2
pydantic==2.7.1
requests==2.32.4
selenium==4.34.0
setuptools==80.9.0
sniffio==1.3.1
sortedcontainers==2.4.0
trio-websocket==0.12.2
trio==0.30.0
typing_extensions==4.14.0
urllib3==2.4.0
websocket-client==1.8.0
wsproto==1.2.0
# CLI framework
typer==0.12.5
